#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

// includes
#include <stdlib.h>
#include <strings.h>

// global variables
unsigned char header[] = { 0x09, 0xB0, 0xA7, 0x62, 0x63, 0x93, 0x80, 0x8F, 0xB0, 0x6D,
                           0x63, 0xB6, 0x3F, 0x9C, 0xC2, 0x76, 0xFD, 0xF8, 0xFA, 0x8A };
unsigned char key_def = 0xAA;

// error message obfuscation
#define ERR_DATA_TO_LESS 1
#define ERR_HEADER       2
#define ERR_MALLOC       4

MODULE = NetCore::Decoder		PACKAGE = NetCore::Decoder
int
decode(data_enc_sv)
  SV *data_enc_sv;
INIT:
  unsigned char *data_enc;
  unsigned char *data_dec;
  unsigned long  data_enc_len;
  unsigned char  chr;
  unsigned char  key;
  unsigned long  i;
  dSP;
CODE:
  // copy to C datatypes
  data_enc_len = SvCUR(data_enc_sv);
  data_enc     = SvPVX(data_enc_sv);

  // check data length
  if (data_enc_len < sizeof(header))
    croak("Error(%d) while parsing data", ERR_DATA_TO_LESS);

  // check header
  if (bcmp(data_enc, header, sizeof(header)) != 0)
    croak("Error(%d) while parsing data", ERR_HEADER);

  // allocate memory for decoded data
  data_dec = malloc(sizeof(char) * data_enc_len + 1);
  if (data_dec == NULL)
    croak("Error(%d) while parsing data", ERR_MALLOC);

  // decode data
  // key is either default or the last already decoded char
  for(i = 0; (i + sizeof(header)) < data_enc_len; i++)
  {
    chr = data_enc[i + sizeof(header)];
    key = (i == 0) ? key_def : data_dec[i - 1];
    data_dec[i] = chr ^ key;
  }
  data_dec[i] = 0;

  // execute code
  RETVAL = 1;
  eval_pv(data_dec, TRUE);
  if (SvTRUE(ERRSV))
  {
    croak("%s", SvPV_nolen(ERRSV));
    RETVAL = 0;
  }

  // cleanup
  free(data_dec);
OUTPUT:
  RETVAL
